/*******************************************************************************
**  DAVE App Name : CLK001       App Version: 1.0.44               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/



/*CODE_BLOCK_BEGIN[CLK001_Conf.h]*/

/******************************************************************************
 *
 * Copyright (C) 2013 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
********************************************************************************
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC1000 Series                                         **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : App Developer                                                   **
**                                                                            **
** MAY BE CHANGED BY USER [yes/Yes]: No                                       **
**                                                                            **
** MODIFICATION DATE : Aug 21, 2013                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials     Name                                                          **
** ---------------------------------------------------------------------------**
** ES           App Developer                                                 **
*******************************************************************************/

/**
 * @file   CLK001_Conf.h
 * @brief <TBD>This file contains the configuration code for the App.
 *
 * Revision History
 * 21 Aug 2013   v1.0.34    Static and configuration code separated.
 * 05 Nov 2013   v1.0.38  Macro name changed from CLK001_CLK001_WDTCLK_EN to 
                          CLK001_WDTCLK_EN. 
 *
 */
#ifndef CLK001_CONF_H_
#define CLK001_CONF_H_

/* Support for C++ codebase */
#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
**                           Include Files                                    **
*******************************************************************************/
#include "CLK001_Const.h"

/*******************************************************************************
**                      Global Macro Definitions                              **
*******************************************************************************/
/*********************************************************/
/* Main PLL Clock Configuration */
/*********************************************************/
/* Main PLL input clock configuration */
#define  CLK001_PLL_CLOCK_INPUT  CLK001_CLOCK_CRYSTAL
/*Oscillator mode = External Crystal Mode*/
#define CLK001_OSC_HP_MODE  0x0UL
/* MAIN PLL setup parameters */  
#define   CLK001_PLL_K1DIV        0UL
#define   CLK001_PLL_K2DIV        3UL      
#define   CLK001_PLL_PDIV         0UL    
#define   CLK001_PLL_NDIV         39UL  
#define   CLK001_PLL_K2DIV_STEP_1    19UL  /*PLL output is 24Mhz*/  
#define   CLK001_PLL_K2DIV_STEP_2    7UL  /*PLL output to 60Mhz*/  
#define   CLK001_PLL_K2DIV_STEP_3    4UL  /*PLL output to 96Mhz*/  
/*PLL mode configuration*/
#define CLK001_CLOCK_PLL_MODE CLK001_CLOCK_PLL_NORMAL
/* Register bit field mask to check if Oscillator is usable */
#define CLK001_PLLSTAT_OSC_USABLE_MASK       (SCU_PLL_PLLSTAT_PLLHV_Msk | \
                                              SCU_PLL_PLLSTAT_PLLLV_Msk | \
                                              SCU_PLL_PLLSTAT_PLLSP_Msk)
/*values for Main PLL frequency stepping*/
#define CLK001_PLL_FREQ_STEP1               (24U * 1000U * 1000U)
#define CLK001_PLL_FREQ_STEP2               (60U * 1000U * 1000U)
#define CLK001_PLL_FREQ_STEP3               (90U * 1000U * 1000U)

/*********************************************************/
/* USB PLL Clock Configuration */
/*********************************************************/
/* USB PLL setup parameters */
#define   CLK001_USBPLL_PDIV      1UL
#define   CLK001_USBPLL_NDIV      63UL
#define   CLK001_USBDIV           3UL

/*********************************************************/
/* Standby Clock Configuration */
/*********************************************************/
/*Standby clock source configuration*/
#define  CLK001_STANDBY_CLOCK  CLK001_HIB_CLOCK_FOSI

/*********************************************************/
/* Backup Clock Configuration */
/*********************************************************/
/*Back up clock trimming option*/
#define CLK001_TRIM_OPTION CLK001_CLOCK_TRIM_AUTOMATIC
/*back up clock frequency*/
#define  CLK001_CLOCK_BACK_UP                24000000UL

/*********************************************************/
/* System Clock Configuration */
/*********************************************************/
/*System clock source configuration*/
#define CLK001_CLOCK_SYS_SRC CLK001_CLOCK_SRC_PLL 
/* system clock frequency */
#define CLK001_CLOCK_FSYS                    120000000UL

/**************************************************************/
/* External Oscillator or External Clock Source Configuration */
/**************************************************************/
/*crystal or digital clock input frequency*/
#define  CLK001_CLOCK_CRYSTAL_FREQUENCY      12000000UL     

/**********************************************************/
/* Macros for Internal, External and System clock Signals */
/**********************************************************/

/*********************************************************/
/* WDT Clock Configuration */
/*********************************************************/
/*Reference frequency for system oscillator watch dog - 2.5 MHz*/
#define  CLK001_SOSCWDG_FREF                 2500000U
#define CLK001_WDT_CLKSRC CLK001_WDTCLK_BACKUP

/*********************************************************/
/* RTC Clock Configuration */
/*********************************************************/
#define CLK001_RTC_CLKSRC CLK001_RTC_CLOCK_FOSI

/*********************************************************/
/* Clock Divider Configuration */
/*********************************************************/
/* WDT Clock Divider Value */
#ifdef CLK001_WDTCLK_EN
  #define CLK001_WDTCLKDIV 0UL
#endif
/* EBU Clock Divider Value */
#ifdef CLK001_EBUCLK_EN
  #define CLK001_EBU_CLKDIV 0UL
#endif

/*********************************************************/
/* External Clock Configuration */
/*********************************************************/
/* External Clock Selection */
#define CLK001_EXTCLK_SEL          CLK001_EXTCLK_SYSTEM_CLOCK
/* External Clock PLL Divider */
#define CLK001_EXTCLK_PLLDIV 0UL


/* Support for C++ codebase */
#ifdef __cplusplus
}
#endif   

#endif /* CLK001_CONF_H_ */

/*CODE_BLOCK_END*/

