/*
 * Main.c
 *
 *  Created on: Dec 15, 2014
 *      Author: toochang
 */

/*
 * Note:
 * - The XMC4500 CAN has got 3 CAN Nodes and a total of 64 Message Objects (MO). However
 *   DAVE3 shall auto assigned these 64 MO to one of these CAN nodes.
 * - Please note that the LMO_01 does not equal to MO01
 * - The understanding of the LMO used in DAVE 3 is described below example.
 *
 * Example:
 * CAN001/0 = Node_2
 * LMO_01 = MO13
 *
 * CAN001/1 = Node_1
 * LMO_01 = MO00
 *
 */
#define LMO_01	1
#define LMO_02	2
#define LMO_03	3
#define LMO_04	4
#define LMO_05	5
#define LMO_06	6
#define LMO_07	7
#define LMO_08	8
#define LMO_09	9
#define LMO_10	10

#define SIZE 8



#include <DAVE3.h>			//Declarations from DAVE3 Code Generation (includes SFR declaration)


int main(void)
{

	status_t Status = CAN001_ERROR;

    uint8_t Data[SIZE] = {0xBC,0x11,0x22,0xA5,0xEF,0xFF,0x89,0x01};

	DAVE_Init();			// Initialization of DAVE Apps

    CAN001_UpdateMODataRegisters(&CAN001_Handle0,LMO_01,SIZE,Data);
    Status = CAN001_SendDataFrame(&CAN001_Handle0,LMO_01);

    if(Status == DAVEApp_SUCCESS)
    {
       // transmit request for sending data frame is set
    }


	while(1)
	{

	}
	return 0;
}

CAN001_MessageHandleType CAN_RxData;

void CAN_Rx_ISR (void)
{
	if(CAN001_GetMOFlagStatus(&CAN001_Handle1,LMO_01,RECEIVE_PENDING) == CAN_SET)
	{
		/* Clear flag status */
		CAN001_ClearMOFlagStatus(&CAN001_Handle1,LMO_01,RECEIVE_PENDING);
		/* Read the received Message object and stores in variable CanRecMsgObj */
		CAN001_ReadMsgObj(&CAN001_Handle1,&CAN_RxData,LMO_01);
	}

}
